// This class solves the Helmholtz equation using SOR 
// Boundary conditions are supplied by the DirichletBC class
// Resolutions methods are supplied by the Resolution class


public class Solver{

    public static int ITER=8000;

    public static void initial(){
	int i, j;
	for(i=1;i<Matrice.phi_old.length-1;i++){
	    for(j=1;j<Matrice.phi_old[0].length-1;j++){
		Matrice.phi_old[i][j]=0.0;
		Matrice.phi_new[i][j]=0.0;
	    }
	}
    }


    public static void output(){
	int i,j;
	for(i=0;i<Matrice.phi_old.length;i++){
	    for(j=0;j<Matrice.phi_old.length;j++){
		System.out.println(i*Domain.ax+" "+j*Domain.ay+" "+Matrice.phi_new[i][j]);
	    }
	}
    }


    public static void main(String[] args){
	int k;

	DirichletBC.bc_up();
	DirichletBC.bc_down();
	DirichletBC.bc_right();
	DirichletBC.bc_left();
	initial();


	for(k=1;k<ITER;k++){
	    Resolution.SOR_Update(0.0,1.7);
//	    System.out.println(k+" "+Resolution.Error());
	    Resolution.Update();
	    }
	
	output();
    }
}
